'
' Lauftext, bei dem man selber laufen muss ;-)
'
'
' Start durch Reset- Taster
' LED- Zeile aus 5 LEDs mit je 150 Ohm Vorwiderstand an PB0 bis PB4
' die Buchstaben werden in einer Matrix 5*5 dargestellt.
' die Text- Darstellung entsteht, wenn man die LED- Zeile schnell bewegt
'
' In Version 3 gibt es drei Texte, zwischen denen umgeschaltet wird
' Die Texte stehen in den Data- Zeilen "String0" bis "String2"
' Damit die Zhlvariable, in der die zuletzt gesandte Version gespeichert wird,
' den Reset "berlebt", wird sie ins Byte 63 des EEPROM geschrieben
'
' Der Textzhler hat 1 Schritt mehr, als Texte vorhanden sind; daher geht der
' letzte Tastendruck "ins leere", so da man weiss, wann die Sequenz beginnt
'
' Version 3a: starre 5*5 Matrix fhrt zu ungleichmigen Zeichenabstnden,
' besonders beim "I". Daher Abbruch der Zeichendarstellung nach der ersten
' Spalte mit Nullen
'
'----------------------------------------------------------
$regfile = "attiny13.dat"
$crystal = 1200000

$hwstack = 32
$swstack = 8
$framesize = 0

Acsr.acd = 1                                                ' Analogen Komparator ausschalten
Ddrb = &B0001_1111                                          ' alle Ports Ausgnge
Portb = &B0000_0000                                         ' alle Ports 0

Enable Interrupts

Dim Leuchtstring As String * 14
Dim Leuchtzeichen As String * 1
Dim Leuchtbyte As Byte At Leuchtzeichen Overlay
Dim Leuchtspalte As Byte
Dim N As Byte
Dim M As Byte
Dim S As Byte

' 4.3.11:  10, 5, 1

Const T1 = 10                                               ' Blinkdauer pro Spalte
Const T2 = 5 * T1                                           ' Zeitdauer fr ein Leerzeichen (ASCII 32)
Const T3 = 1 * T1


'----------------------------------------------------------

Do

Waitms 100

Readeeprom S , 63


Select Case S

Case 0 : Restore String0
          Read Leuchtstring
Case 1 : Restore String1
          Read Leuchtstring
Case 2 : Restore String2
          Read Leuchtstring
End Select


For N = 1 To Len(leuchtstring)

  Leuchtzeichen = Mid(leuchtstring , N , 1)
'  Leuchtbyte = Asc(leuchtzeichen)                           ' auskommentiert, weil durch Overlay- Variable ersetzt
  If Leuchtbyte = 32 Then                                   ' Leerzeichen -> 40 msec Nichtstun
     Portb = 0
     Waitms T2
     Goto Leer
  End If
  Leuchtbyte = Leuchtbyte - 64                              ' Ascii- Grossbuchstaben beginnen bei 65
  Leuchtbyte = Leuchtbyte * 5                               ' Buchstabenbeginn jeweils bei jeder 5. Data- Zeile


  For M = 1 To 5                                            ' Buchstaben spaltenweise darstellem
     Leuchtspalte = Lookup(leuchtbyte , Bitmatrix)
     Portb = Leuchtspalte
     Leuchtbyte = Leuchtbyte + 1                            ' nchste Data- Zeile ansteuern
     Waitms T1
     If Leuchtspalte = 0 Then
       Goto Abbruch
     End If
  Next M

Abbruch:
  Portb = 0
  Waitms T3

Leer:
Next N


S = S + 1
  If S > 3 Then
     S = 0
  End If
Writeeeprom S , 63

Powerdown

Loop





'----------------------------------------------------------



String0:                                                    ' nur Grossbuchstaben zulssig

Data "WERDER"

String1:

Data "BREMEN"

String2:

Data "WINNER"



Bitmatrix:


  ' (@ : Test - ergibt fallende Treppe)
' Data &B00001
' Data &B00010
' Data &B00100
' Data &B01000
' Data &B10000

' (@ : -  ergibt Punkt)
 Data &B01100
 Data &B01100
 Data &B00000
 Data &B00000
 Data &B00000

'A:
Data &B11000
Data &B00110
Data &B00101
Data &B00110
Data &B11000


'B:
Data &B11111
Data &B10101
Data &B10101
Data &B01010
Data &B00000

'C:
Data &B01110
Data &B10001
Data &B10001
Data &B10001
Data &B00000

'D:
Data &B11111
Data &B10001
Data &B10001
Data &B01110
Data &B00000

'E:
Data &B11111
Data &B10101
Data &B10101
Data &B10101
Data &B00000

'F:
Data &B11111
Data &B00101
Data &B00101
Data &B00101
Data &B00000

'G:
Data &B01110
Data &B10001
Data &B10100
Data &B01100
Data &B00000

'H:
Data &B11111
Data &B00100
Data &B00100
Data &B11111
Data &B00000

'I:
Data &B11111
Data &B00000
Data &B00000
Data &B00000
Data &B00000

'J:
Data &B10000
Data &B10000
Data &B01111
Data &B00000
Data &B00000

'K:
Data &B11111
Data &B00100
Data &B01010
Data &B10001
Data &B00000

'L:
Data &B11111
Data &B10000
Data &B10000
Data &B10000
Data &B00000

'M:
Data &B11111
Data &B00011
Data &B00100
Data &B00011
Data &B11111

'N:
Data &B11111
Data &B00010
Data &B00100
Data &B01000
Data &B11111

'O:
Data &B01110
Data &B10001
Data &B10001
Data &B01110
Data &B00000

'P:
Data &B11111
Data &B00101
Data &B00101
Data &B00010
Data &B00000

'Q:
Data &B01110
Data &B10001
Data &B11001
Data &B11110
Data &B00000

'R:
Data &B11111
Data &B00101
Data &B01101
Data &B10010
Data &B00000

'S:
Data &B10011
Data &B10101
Data &B10101
Data &B01001
Data &B00000

'T:
Data &B00001
Data &B00001
Data &B11111
Data &B00001
Data &B00001

'U:
Data &B01111
Data &B10000
Data &B10000
Data &B01111
Data &B00000

'V:
Data &B00011
Data &B01000
Data &B10000
Data &B01000
Data &B00011

'W:
Data &B00111
Data &B11000
Data &B00111
Data &B11000
Data &B00111

'X:
Data &B10001
Data &B01010
Data &B00100
Data &B01010
Data &B10001

'Y:
Data &B00011
Data &B00100
Data &B10000
Data &B00100
Data &B00011

'Z:
Data &B10001
Data &B11001
Data &B10101
Data &B10011
Data &B00000